"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GQLElement = void 0;
const Meta_1 = require("./Meta");
class GQLElement extends Meta_1.Meta {
    constructor(name) {
        super();
        this.setName(name);
        this._ref = Symbol();
    }
    get description() {
        return this._description;
    }
    get ref() {
        return this._ref;
    }
    get name() {
        return this._name;
    }
    get built() {
        return this._built;
    }
    static built(elements) {
        return elements.map((e) => e.built);
    }
    static create(...args) {
        throw new Error("Method not overridden");
    }
    build(...args) {
        throw new Error("Method not overridden");
    }
    setName(name) {
        this._name = name;
        return this;
    }
    setDescription(description) {
        this._description = description;
        return this;
    }
}
exports.GQLElement = GQLElement;
//# sourceMappingURL=GQLElement.js.map