import { GraphQLField, GraphQLInputField } from "graphql";
import { FieldType, GQLElement, InputFieldType, NotNullableType, KeyValue } from "../..";
export declare abstract class GQLField<BuiltType = any, NameType = string, MetaType = KeyValue> extends GQLElement<BuiltType, NameType, MetaType> {
    protected _type: FieldType | InputFieldType;
    protected _deprecationReason: string;
    protected _description: string;
    get type(): StringConstructor | BooleanConstructor | NumberConstructor | DateConstructor | import("graphql").GraphQLScalarType | import("../..").InputType<any, KeyValue> | import("../..").EnumType<any, KeyValue> | InputFieldType[] | NotNullableType<InputFieldType> | import("../..").NullableType<FieldType> | import("../..").GQLObjectType<any, any, KeyValue> | import("../..").EnumType<any, KeyValue> | import("../..").UnionType<KeyValue> | FieldType[] | NotNullableType<FieldType> | import("../..").NullableType<FieldType>;
    get description(): string;
    get deprecationReason(): string;
    constructor(name: NameType & string, type: FieldType | InputFieldType);
    abstract build(): GraphQLField<any, any, any> | GraphQLInputField;
    /**
     * Set the field type
     * @param type the type of your field
     */
    setType(type: FieldType | InputFieldType): this;
    /**
     * Set the description of the field
     * @param deprecationReason The deprecation reason
     */
    setDescription(description: string): this;
    /**
     * Set the deprecation reason of the field
     * @param deprecationReason The deprecation reason
     */
    setDeprecationReason(deprecationReason: string): this;
    /**
     * Convert your field type into a nullable type
     */
    nullable(): this;
    /**
     * Convert your field type into a not nullable type
     */
    required(): this;
}
